//////////////////////////////////////////////////////////////////////////////////
//
// SQLResultSetTablePane example.
//
//////////////////////////////////////////////////////////////////////////////////
//
// This source is an example of IBM Toolbox for Java "SQLResultSetTablePane"
// IBM grants you a nonexclusive license to use this as an example
// from which you can generate similar function tailored to
// your own specific needs.
//
// This sample code is provided by IBM for illustrative purposes
// only. These examples have not been thoroughly tested under all
// conditions. IBM, therefore, cannot guarantee or imply
// reliability, serviceability, or function of these programs.
//
// All programs contained herein are provided to you "AS IS"
// without any warranties of any kind.  The implied warranties of
// merchantablility and fitness for a particular purpose are
// expressly disclaimed.
//
// IBM Toolbox for Java
// (C) Copyright IBM Corp. 1998, 1998
// All rights reserved.
// US Government Users Restricted Rights -
// Use, duplication, or disclosure restricted
// by GSA ADP Schedule Contract with IBM Corp.
//
//////////////////////////////////////////////////////////////////////////////////

import com.ibm.as400.access.AS400JDBCDriver;
import com.ibm.as400.vaccess.ErrorDialogAdapter;
import com.ibm.as400.vaccess.SQLConnection;
import com.ibm.as400.vaccess.SQLResultSetTablePane;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.sql.*;


public class SQLResultSetTablePaneExample
extends KeyAdapter {


  private static SQLResultSetTablePane    tablePane_;
  private static JTextField               textField_;


  public static void main(String argv[])
  {
    try {
      // Register the IBM Toolbox for Java JDBC driver.
      DriverManager.registerDriver(new AS400JDBCDriver());

      // ---------------------------------------------------------------
      //             Lab Exercise #3 Part #1 - Insert code here.
      // ---------------------------------------------------------------

      SQLConnection connection = new SQLConnection("jdbc:as400://");

      // ---------------------------------------------------------------
      //                           End of code.
      // ---------------------------------------------------------------

      // ---------------------------------------------------------------
      //             Lab Exercise #3 Part #2 - Insert code here.
      // ---------------------------------------------------------------

      SQLResultSetTablePane tablePane = new SQLResultSetTablePane();
      tablePane.setConnection (connection);

      // ---------------------------------------------------------------
      //                           End of code.
      // ---------------------------------------------------------------

      // Store the table pane in a static variable.
      tablePane_ = tablePane;

      // Initialize the text area.
      textField_ = new JTextField ("Enter an SQL query here.");
      textField_.addKeyListener (new SQLResultSetTablePaneExample ());

      // Initialize the frame.
      JFrame frame = new JFrame ("SQLResultSetTablePane example");
      frame.getContentPane ().setLayout (new BorderLayout ());
      frame.getContentPane ().add ("North", textField_);
      frame.getContentPane ().add ("Center", tablePane_);

      // When the frame closes, exit the program.
      frame.addWindowListener (new WindowAdapter ()
      {
        public void windowClosing (WindowEvent event) { System.exit (0);}
      });

      // ---------------------------------------------------------------
      //             Lab Exercise #3 Part #4 - Insert code here.
      // ---------------------------------------------------------------

      ErrorDialogAdapter errorHandler = new ErrorDialogAdapter (tablePane);
      tablePane.addErrorListener (errorHandler);

      // ---------------------------------------------------------------
      //                           End of code.
      // ---------------------------------------------------------------

      // Display the frame.
      frame.pack();
      frame.show();
    } catch (Exception e) {
      System.out.println ("Error: " + e);
    }
  }


  // This gets called whenever a key is pressed in the text area.
  public void keyPressed (KeyEvent event)
  {
    try {

      // Check for the Enter key.
      if (event.getKeyCode () == KeyEvent.VK_ENTER) {
        String queryText = textField_.getText ();

        SQLResultSetTablePane tablePane = tablePane_;

        // ---------------------------------------------------------------
        //             Lab Exercise #3 Part #3 - Insert code here.
        // ---------------------------------------------------------------

        tablePane.setQuery (queryText);
        tablePane.load ();

        // ---------------------------------------------------------------
        //                           End of code.
        // ---------------------------------------------------------------
      }
    } catch (Exception e) {
      System.out.println ("Error: " + e);
    }
  }
}
